/* Copyright (C) 1989 Aladdin Enterprises.  All rights reserved.
   Distributed by Free Software Foundation, Inc.

This file is part of Ghostscript.

Ghostscript is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY.  No author or distributor accepts responsibility
to anyone for the consequences of using it or for whether it serves any
particular purpose or works at all, unless he says so in writing.  Refer
to the Ghostscript General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
Ghostscript, but only under the conditions described in the Ghostscript
General Public License.  A copy of this license is supposed to have been
given to you along with Ghostscript so you can know your rights and
responsibilities.  It should be in a file named COPYING.  Among other
things, the copyright notice and this notice must be preserved on all
copies.  */

/* std.h */
/* Standard definitions for LPD's C programs */

/* Note: we assume that __STDC__ is defined for ANSI-standard compilers, */
/* and that __MSDOS__ is defined for Turbo C and not for Unix. */

/* Miscellaneous types */
typedef unsigned char byte;
typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned int uint;
typedef unsigned long ulong;

/* The type to be used for comparing pointers for order (<, >=, etc.). */
/* Turbo C large model doesn't compare pointers per se correctly. */
#ifdef __MSDOS__
typedef unsigned long ptr_ord_t;
#else
typedef char *ptr_ord_t;
#endif

/* In case stdio.h doesn't have these: */
#ifndef min
#define min(a, b) ((a) < (b) ? (a) : (b))
#endif
#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif

/* math.h is different for Turbo and Unix.... */
#ifndef M_PI
#  ifdef PI
#    define M_PI PI
#  else
#    define M_PI 3.14159265358979324
#  endif
#endif

/* K&R specifies that float parameters get converted to double. */
/* Most compilers allow a formal parameter to be declared float, */
/* and treat it as though it had been declared double; however, */
/* Turbo C (and perhaps the ANSI standard) doesn't allow this. */
/* Pending a deeper understanding of this issue, we define a */
/* special type for float parameters. */
#ifdef __STDC__
typedef double floatp;
#else
typedef float floatp;
#endif

/* Macros for argument templates.  ANSI has these, */
/* but most Unix compilers don't. */
#ifdef __STDC__
# define P1(t1) t1
# define P2(t1,t2) t1,t2
# define P3(t1,t2,t3) t1,t2,t3
# define P4(t1,t2,t3,t4) t1,t2,t3,t4
# define P5(t1,t2,t3,t4,t5) t1,t2,t3,t4,t5
# define P6(t1,t2,t3,t4,t5,t6) t1,t2,t3,t4,t5,t6
# define P7(t1,t2,t3,t4,t5,t6,t7) t1,t2,t3,t4,t5,t6,t7
# define P8(t1,t2,t3,t4,t5,t6,t7,t8) t1,t2,t3,t4,t5,t6,t7,t8
# define P9(t1,t2,t3,t4,t5,t6,t7,t8,t9) t1,t2,t3,t4,t5,t6,t7,t8,t9
# define P10(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10)\
   t1,t2,t3,t4,t5,t6,t7,t8,t9,t10
# define P11(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11)\
   t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11
# define P12(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12)\
   t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
#else
# define P1(t1)
# define P2(t1,t2)
# define P3(t1,t2,t3)
# define P4(t1,t2,t3,t4)
# define P5(t1,t2,t3,t4,t5)
# define P6(t1,t2,t3,t4,t5,t6)
# define P7(t1,t2,t3,t4,t5,t6,t7)
# define P8(t1,t2,t3,t4,t5,t6,t7,t8)
# define P9(t1,t2,t3,t4,t5,t6,t7,t8,t9)
# define P10(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10)
# define P11(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11)
# define P12(t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12)
#endif
